using System;
using System.Data;
using System.Collections.Generic;

public class Publisher {

    public List<Author> LookupAuthorsByState (String state) {

        // Obtain DataSet of Authors from DAL
        DataSet ds = AuthorsDB.GetAuthorsByState (state);

        // Return Strongly Typed Generic Collection of Authors
        List<Author> authors = new List<Author>();
        
        foreach (DataRow row in ds.Tables[0].Rows) {
            authors.Add(new Author((String)row["au_id"], (String)row["au_fname"], (String)row["au_lname"], (String)row["address"], (String)row["city"], (String)row["state"], (String)row["zip"],(String)row["phone"], (bool)row["contract"]));
        }

        return authors;
    }

    public Author LookupAuthorDetails(string ID)
    {
        // Obtain DataSet of Authors from DAL
        DataSet ds = AuthorsDB.GetAuthorDetails(ID);
        Author author = null;

        if (ds.Tables[0].Rows.Count > 0)
        {
            DataRow row = ds.Tables[0].Rows[0];
            author = new Author((String)row["au_id"], (String)row["au_fname"], (String)row["au_lname"], (String)row["address"], (String)row["city"], (String)row["state"], (String)row["zip"], (String)row["phone"], (bool)row["contract"]);
        }

        return author;
    }

    public void UpdateAuthor(Author author)
    {
        AuthorsDB.UpdateAuthor(author.ID, author.LastName, author.Name, author.Phone, author.Address, author.City, author.State, author.Zip, author.Contact);
    }
}
