using System;
using System.Configuration;

public class AuthorsDB {

    private static string ConnectionString = "server=(local);database=pubs;trusted_connection=true";

    public static System.Data.DataSet GetAuthorDetails(string authorid)
    {
        System.Data.IDbConnection dbConnection = new System.Data.SqlClient.SqlConnection(ConnectionString);
        string queryString = "SELECT * FROM [authors] WHERE ([authors].[au_id] = @authorid)";
        System.Data.IDbCommand dbCommand = new System.Data.SqlClient.SqlCommand();

        dbCommand.CommandText = queryString;
        dbCommand.Connection = dbConnection;

        System.Data.IDataParameter dbParam_authorid = new System.Data.SqlClient.SqlParameter();

        dbParam_authorid.ParameterName = "@authorid";
        dbParam_authorid.Value = authorid;
        dbParam_authorid.DbType = System.Data.DbType.StringFixedLength;
        dbCommand.Parameters.Add(dbParam_authorid);

        System.Data.IDbDataAdapter dataAdapter = new System.Data.SqlClient.SqlDataAdapter();

        dataAdapter.SelectCommand = dbCommand;

        System.Data.DataSet dataSet = new System.Data.DataSet();

        dataAdapter.Fill(dataSet);
        return dataSet;
    }

    public static System.Data.DataSet GetAuthorsByState(string state) {

        System.Data.IDbConnection dbConnection = new System.Data.SqlClient.SqlConnection(ConnectionString);
        string queryString = "SELECT * FROM [authors] WHERE ([authors].[state] = @state)";
        System.Data.IDbCommand dbCommand = new System.Data.SqlClient.SqlCommand();

        dbCommand.CommandText = queryString;
        dbCommand.Connection = dbConnection;

        System.Data.IDataParameter dbParam_state = new System.Data.SqlClient.SqlParameter();

        dbParam_state.ParameterName = "@state";
        dbParam_state.Value = state;
        dbParam_state.DbType = System.Data.DbType.StringFixedLength;
        dbCommand.Parameters.Add(dbParam_state);

        System.Data.IDbDataAdapter dataAdapter = new System.Data.SqlClient.SqlDataAdapter();

        dataAdapter.SelectCommand = dbCommand;

        System.Data.DataSet dataSet = new System.Data.DataSet();

        dataAdapter.Fill(dataSet);
        return dataSet;
    }


    public static int UpdateAuthor(string au_id, string au_lname, string au_fname, string phone, string address, string city, string state, string zip, bool contract)
    {
        string connectionString = "server=\'(local)\'; trusted_connection=true; database=\'pubs\'";
        System.Data.IDbConnection dbConnection = new System.Data.SqlClient.SqlConnection(connectionString);

        string queryString = "UPDATE [authors] SET [au_lname]=@au_lname, [au_fname]=@au_fname, [phone]=@phone, " +
"[address]=@address, [city]=@city, [state]=@state, [zip]=@zip, [contract]=@contra" +
"ct WHERE ([authors].[au_id] = @au_id)";
        System.Data.IDbCommand dbCommand = new System.Data.SqlClient.SqlCommand();
        dbCommand.CommandText = queryString;
        dbCommand.Connection = dbConnection;

        System.Data.IDataParameter dbParam_au_id = new System.Data.SqlClient.SqlParameter();
        dbParam_au_id.ParameterName = "@au_id";
        dbParam_au_id.Value = au_id;
        dbParam_au_id.DbType = System.Data.DbType.String;
        dbCommand.Parameters.Add(dbParam_au_id);
        System.Data.IDataParameter dbParam_au_lname = new System.Data.SqlClient.SqlParameter();
        dbParam_au_lname.ParameterName = "@au_lname";
        dbParam_au_lname.Value = au_lname;
        dbParam_au_lname.DbType = System.Data.DbType.String;
        dbCommand.Parameters.Add(dbParam_au_lname);
        System.Data.IDataParameter dbParam_au_fname = new System.Data.SqlClient.SqlParameter();
        dbParam_au_fname.ParameterName = "@au_fname";
        dbParam_au_fname.Value = au_fname;
        dbParam_au_fname.DbType = System.Data.DbType.String;
        dbCommand.Parameters.Add(dbParam_au_fname);
        System.Data.IDataParameter dbParam_phone = new System.Data.SqlClient.SqlParameter();
        dbParam_phone.ParameterName = "@phone";
        dbParam_phone.Value = phone;
        dbParam_phone.DbType = System.Data.DbType.StringFixedLength;
        dbCommand.Parameters.Add(dbParam_phone);
        System.Data.IDataParameter dbParam_address = new System.Data.SqlClient.SqlParameter();
        dbParam_address.ParameterName = "@address";
        dbParam_address.Value = address;
        dbParam_address.DbType = System.Data.DbType.String;
        dbCommand.Parameters.Add(dbParam_address);
        System.Data.IDataParameter dbParam_city = new System.Data.SqlClient.SqlParameter();
        dbParam_city.ParameterName = "@city";
        dbParam_city.Value = city;
        dbParam_city.DbType = System.Data.DbType.String;
        dbCommand.Parameters.Add(dbParam_city);
        System.Data.IDataParameter dbParam_state = new System.Data.SqlClient.SqlParameter();
        dbParam_state.ParameterName = "@state";
        dbParam_state.Value = state;
        dbParam_state.DbType = System.Data.DbType.StringFixedLength;
        dbCommand.Parameters.Add(dbParam_state);
        System.Data.IDataParameter dbParam_zip = new System.Data.SqlClient.SqlParameter();
        dbParam_zip.ParameterName = "@zip";
        dbParam_zip.Value = zip;
        dbParam_zip.DbType = System.Data.DbType.StringFixedLength;
        dbCommand.Parameters.Add(dbParam_zip);
        System.Data.IDataParameter dbParam_contract = new System.Data.SqlClient.SqlParameter();
        dbParam_contract.ParameterName = "@contract";
        dbParam_contract.Value = contract;
        dbParam_contract.DbType = System.Data.DbType.Boolean;
        dbCommand.Parameters.Add(dbParam_contract);

        int rowsAffected = 0;
        dbConnection.Open();
        try
        {
            rowsAffected = dbCommand.ExecuteNonQuery();
        }
        finally
        {
            dbConnection.Close();
        }

        return rowsAffected;
    }


/*
    public static int UpdateAuthor (string au_id, string au_lname, string au_fname, string state) {

        System.Data.IDbConnection dbConnection = new System.Data.SqlClient.SqlConnection(ConnectionString);
        string queryString = "UPDATE [authors] SET [au_lname]=@au_lname, [au_fname]=@au_fname, [state]=@state WHERE ([authors].[au_id] = @au_id)";
        System.Data.IDbCommand dbCommand = new System.Data.SqlClient.SqlCommand();

        dbCommand.CommandText = queryString;
        dbCommand.Connection = dbConnection;

        System.Data.IDataParameter dbParam_au_id = new System.Data.SqlClient.SqlParameter();

        dbParam_au_id.ParameterName = "@au_id";
        dbParam_au_id.Value = au_id;
        dbParam_au_id.DbType = System.Data.DbType.String;
        dbCommand.Parameters.Add(dbParam_au_id);

        System.Data.IDataParameter dbParam_au_lname = new System.Data.SqlClient.SqlParameter();

        dbParam_au_lname.ParameterName = "@au_lname";
        dbParam_au_lname.Value = au_lname;
        dbParam_au_lname.DbType = System.Data.DbType.String;
        dbCommand.Parameters.Add(dbParam_au_lname);

        System.Data.IDataParameter dbParam_au_fname = new System.Data.SqlClient.SqlParameter();

        dbParam_au_fname.ParameterName = "@au_fname";
        dbParam_au_fname.Value = au_fname;
        dbParam_au_fname.DbType = System.Data.DbType.String;
        dbCommand.Parameters.Add(dbParam_au_fname);

        System.Data.IDataParameter dbParam_state = new System.Data.SqlClient.SqlParameter();

        dbParam_state.ParameterName = "@state";
        dbParam_state.Value = state;
        dbParam_state.DbType = System.Data.DbType.StringFixedLength;
        dbCommand.Parameters.Add(dbParam_state);

        int rowsAffected = 0;

        dbConnection.Open();

        try {
            rowsAffected = dbCommand.ExecuteNonQuery();
        }
        finally {
            dbConnection.Close();
        }
        return rowsAffected;
    }

    */
}
